import 'package:flight_script/flight_script.dart';

/// as well as using dart to call flight, we can use flight to call dart functions
/// dart functions interact with the vm via the dart_api - this allows a large amount of
/// control, but it's usual to just pop the values you want as parameters off the stack and
/// push your results (see Lua's C API)
///
/// Note - there are no language-level identifiers in flight - all of the standard functions
/// are defined using the dart api
const program = """
  2 -3 1 4 quadratic 
""";

void main() {
  final interpreter = Interpreter();

  interpreter.bind("quadratic", (vm) {
    // remember, values will pop off in the reverse order that they're pushed
    final x = vm.pop();
    final c = vm.pop();
    final b = vm.pop();
    final a = vm.pop();

    final y = (a * x * x) + (b * x) + c;

    vm.push(y);
  });

  final result = interpreter.eval(program);
  print(result);
}
