import 'dart:io';

import 'package:flight_script/flight_script.dart';

/// FlightScript is usually stored in .fss (flight-script-source) files (to avoid
/// confusion with F#'s .fs files
void main() {
  for (final script in _flightScriptExamples()) {
    print("---------------");
    print(script);
    print("---------------");

    final interpreter = Interpreter();
    interpreter.eval(script);

    print("---------------");
  }
}

Iterable<String> _flightScriptExamples() sync* {
  final Directory dir = Directory('.');
  for (final file in dir.listSync(recursive: true)
    ..sort((a, b) => a.path.compareTo(b.path))) {
    if (file is File &&
        file.path.endsWith(".fss") &&
        file.path.contains("example")) {
      yield file.readAsStringSync();
    }
  }
}
