import 'dictionary.dart';
import 'macro.dart';
import 'virtual_machine.dart';

class FlightFunction {
  final Macro macro;
  final Dictionary closure;

  String? _name;

  FlightFunction(this.macro, this.closure);

  String get name => _name ?? "?anonymous¿";

  void set name(String value) => _name = value;

  @override
  String toString() {
    return "fn($name)";
  }
}

/// As with the macro listener, we wait to see a function and then call it correctly
/// This depends on finding a macro listener in the stack
class FlightFunctionListener extends ValueListener {
  @override
  invoke(VirtualMachine vm, value, ValueCallback next) {
    if (value is FlightFunction) {
      vm.pushScope(value.closure);
      vm.eval(value.macro);
      vm.popScope();
      return;
    }
    return next(value);
  }
}
