import 'virtual_machine.dart';

/// The host function listener evaluates dart functions that are passed into the
/// vm
/// we might one day need a way to leave a dart function on the stack or use it
/// with a closure, but I haven't found this use case yet
class HostFunctionListener extends ValueListener {
  @override
  invoke(VirtualMachine vm, dynamic value, ValueCallback next) {
    if (value is DartFunction) {
      return value.call(vm);
    }
    return next(value);
  }
}

/// A simple dart function that has access to the vm instance
/// An extension API is probably useful to give this more features
typedef DartFunction = void Function(VirtualMachine vm);
