import 'dart:io';

import 'package:flight_script/flight_script.dart';

void main() {
  final readme_file = File("README.md");
  final readme_template = File("README.md.template");

  if (readme_file.existsSync()) {
    readme_file.deleteSync();
  }
  readme_file.create();

  final builder = StringBuffer();

  builder.write(readme_template.readAsStringSync());

  for (final example in _flightScriptExamples()) {
    builder.write("```\n$example\n```\n```\n");

    final vm = Interpreter();
    vm.bind("print", (vm) {
      builder.write("${vm.pop()}\n");
    });
    vm.eval(example);
    builder.write("```\n--------------\n");
  }

  readme_file.writeAsStringSync(builder.toString());
}

/// copy pasted from examples - bad but there's no-where better for it
Iterable<String> _flightScriptExamples() sync* {
  final Directory dir = Directory('.');
  for (final file in dir.listSync(recursive: true)
    ..sort((a, b) => a.path.compareTo(b.path))) {
    if (file is File &&
        file.path.endsWith(".fss") &&
        file.path.contains("example")) {
      yield file.readAsStringSync();
    }
  }
}
